<p align="center">
  <a href="https://doc.antdf.xyz">
    <img width="200" src="https://gw.alipayobjects.com/zos/rmsportal/KDpgvguMpGfqaHPjicRK.svg">
  </a>
</p>

<h1 align="center">Ant Design Flutter</h1>

<div align="center">

A Flutter UI framework designed for web / pc application, contains some high quality widgets.

Since antdf is designed for pc application at very first, so it wasn't recommand to use in mobile application even can be used.

![Status](https://img.shields.io/badge/STATUS-WIP-orange?style=for-the-badge&color=blue) ![Pub Version](https://img.shields.io/pub/v/ant_design_flutter?style=for-the-badge) ![GitHub](https://img.shields.io/github/license/CalsRanna/ant_design_flutter?style=for-the-badge)

</div>

[![](https://gw.alipayobjects.com/mdn/rms_08e378/afts/img/A*Yl83RJhUE7kAAAAAAAAAAABkARQnAQ)](https://doc.antdf.xyz)

## ✨ Features

- 🌈 Enterprise-class UI designed for web / desktop applications.
- 📦 A set of high-quality Flutter widgets out of the box.
- 🛡 Written in pure Dart with null safety.

## 🖥 Environment Support

- Working on Windows and Mac OS

## 📦 Install

```bash
flutter pub add ant_design_flutter
```

## 🔨 Usage

```dart
import 'package:ant_design_flutter/antdf.dart';

void main() {
  runApp(const AntApp(
    home: Scaffold(
      body: Center(
        child: Button(
          type: ButtonType.primary,
          child: Text("Click Me"),
        ),
      )
    ),
  ));
}
```

### Null Safety

`antdf` is written in dart with null safety, check [Sound Null Safety](https://flutter.cn/posts/announcing-dart-2-12#%E5%81%A5%E5%85%A8%E7%9A%84%E7%A9%BA%E5%AE%89%E5%85%A8) to get started.

## 🔗 Links

- [Home page](https://doc.antdf.xyz)
- [Widgets Overview](https://doc.antdf.xyz/#/overview)

## ⌨️ Development

Use Gitpod, a free online dev environment for GitHub.

[![Open in Gitpod](https://gitpod.io/button/open-in-gitpod.svg)](https://gitpod.io/#https://github.com/CalsRanna/ant_design_flutter)

Or clone locally:

```bash
$ git git@github.com:CalsRanna/ant_design_flutter
$ cd ant_design_flutter
$ flutter pub get
$ flutter run
```

Now flutter will run on the connected device in your environment.

## 🤝 Contributing [![PR Welcome](https://img.shields.io/badge/PR-WELCOME-brightgreen.svg?style=flat-square)](https://github.com/CalsRanna/ant_design_flutter/pulls)

We welcome all contributions. You can submit any ideas as [pull requests](https://github.com/CalsRanna/ant_design_flutter/pulls) or as [GitHub issues](https://github.com/CalsRanna/ant_design_flutter/issues).

[![Let's fund issues in this repository](https://issuehunt.io/static/embed/issuehunt-button-v1.svg)](https://issuehunt.io/r/CalsRanna/ant_design_flutter)

## ❤️ Sponsors and Backers
